---
title: Widget samples
author: Claudio Driussi
description: Some common widgets written with Bootstrap and Almoststatic

hero:
  id: hero
  image: hero/hero1.jpg
  text: |
    Some common widgets. Look ad source code to learn how to built your own
    and to see some best practics

blog:
  tags: [page, widgets]
  categories: [python, widgets]

content:
  - type: text_html
    id: intro
    class: info-box
    text: |
      ## Widgets
      [Bootstrap](https://getbootstrap.com/) is a rich and versatile css system
      used by millions to write frontend contents.

      Here I share a few *"widgets"* based on bootstrap samples. Widgets are
      commented in source code.

  - type: divider
    title: Simple text

  - type: text_html
    id: text1
    style: "
      background-color: lavender;
      padding: 0px 6px  0px 6px;
      "
    text: |
      ## html or markdown text

      The simple component is *html_text*, in which you can write plain text.
      And can give him some style with *style* parameter.

  - type: divider
    title: Carousel
    description: an often used widget

  - type: semantic
    id: article1
    element: article
    open: True

  - type: carousel
    id: carousel1
    class: carousel-fade
    tags: ["carousel-caption-bg"]
    btn_class: "btn btn-primary btn-lg"
    slides:
      - image: [carousel1/slide1.jpg, "image_class", "image_alt"]
        align: text-start
        text: |
          # My first image

          This is a markdown *embedded* into a yaml file
          <b>bold text with inline html</b>

          Second row with an empty line between.
        buttons: [["Learn more", "#"]]

      - image: [carousel1/slide2.jpg, "image_class1", "image_alt1"]
        text: |
          # My second image
          Another wonderful text, inline.

        buttons:
          [
            ["Gallery", "#", "btn btn-info"],
            ["Once more", "#", "btn btn-primary"],
          ]

      - image: [carousel1/slide3.jpg, "image_class2", "image_alt2"]
        align: text-end
        text: |
          # lorem text
          Exercitation nisi officia sint elit. Laboris excepteur do officia est aliquip voluptate esse mollit culpa velit exercitation. Amet incididunt elit cillum dolor quis cillum. Voluptate id ad consequat duis proident fugiat elit dolor quis reprehenderit id. Sunt et aliqua elit irure nisi id irure sint irure aliquip id eu. Cupidatat duis sit consectetur voluptate. Velit amet quis proident esse sit.
        buttons: [["Learn more", "#", "btn btn-info"]]

  - type: divider
    title: Jumbotron
    text: Note the parallax effect

  - type: jumbotron
    id: jumbo1
    class: parallax
    btn_class: "btn btn-primary btn-lg"
    style: '
      background-image: url({{get_media("gradient1.jpg")}});
      background-size: cover contain;
      min-width: 100%;
      height: 16em;
      color: white;
      '
    title: My jumbo
    text: |
      In duis pariatur aute qui tempor ipsum consectetur deserunt est adipisicing qui.

    buttons:
      [
        ["Learn more &raquo;", "#", "", 'target="_blank"'],
        ["And more... &raquo;", "#", "btn btn-secondary btn-lg", ""],
      ]

  - type: semantic
    id: article1
    element: article
    open: False

  - type: divider
    title: Tabbed
    text: |
      There are two styles of tabbed, you can control them with "tabs_style", to activate pills set "tabs_style: nav-pills mb-3"

  - type: tabbed
    id: my_tab
    style: "
      border: 1px solid #cccccc;
      "
    # tabs_style: nav-pills mb-3
    tabs:
      - label: tab1
        active: True
        text: |
          ## tab 1
          Magna exercitation proident ex mollit do ullamco quis qui ad occaecat deserunt tempor et.
          Anim consequat aliqua excepteur quis nisi.

      - label: tab2
        text: |
          ## tab 2
          Voluptate nostrud proident officia pariatur deserunt anim cillum commodo tempor nisi.
          Anim Lorem magna qui sunt commodo consectetur anim aute labore commodo magna voluptate dolor qui.

      - label: tab3
        text: |
          ## tab 3
          Elit eu eiusmod ad id cillum velit.
          Nisi in excepteur culpa amet velit adipisicing nulla.

  - type: divider
    title: Accordion

  - type: accordion
    id: fisa1
    # change the style of accordion
    # class: accordion-flush
    # open: True
    # btn_class: "btn btn-link"
    cards:
      - button: "click me (card 1)"
        show: True
        text: |
          Aute sunt Lorem aute sunt esse et enim dolore ad voluptate nisi occaecat. Sint consectetur eu aliquip ex elit. Tempor sunt ea culpa in laboris culpa laborum culpa. Laboris aliquip occaecat magna sunt culpa sit consequat sit. Et ex amet sint irure aute commodo laborum pariatur est do laborum. Officia eu non laboris ipsum qui. Eu nostrud voluptate sunt do cillum do aute.

      - button: "click me (card 2)"
        text: |
          Consequat mollit laboris voluptate ex laboris esse nostrud esse. Incididunt labore aliquip excepteur consequat. Nisi enim aliqua id reprehenderit exercitation dolore labore ea ea. Labore ex velit ut proident mollit sint velit ipsum laborum occaecat duis consectetur. Culpa in sint aliqua in id id id nostrud aliqua laborum fugiat sunt veniam.

          Dolore et ad dolor aliqua sunt ullamco magna consequat aliquip cillum culpa cillum. Lorem in pariatur laborum aute deserunt enim irure quis qui voluptate fugiat anim. Cillum qui cupidatat ut cupidatat id commodo irure ut. Fugiat commodo in quis esse esse proident et reprehenderit qui velit irure do culpa. Sunt laborum laboris elit officia quis fugiat non dolor aliqua.

      - button: "click me (card 3)"
        show: True
        text: |
          # Title
          Tempor cupidatat laborum consectetur eiusmod cupidatat exercitation reprehenderit Lorem adipisicing cillum esse id nisi laborum. Id tempor amet esse sint ex minim. Non aliquip dolore dolore Lorem sunt quis do reprehenderit velit nostrud excepteur elit nostrud mollit. Do sint ea magna magna. Consequat ut ad labore esse excepteur incididunt dolore aliquip pariatur dolore in proident. Laborum dolor laborum nostrud fugiat est est velit ipsum. Ipsum incididunt esse sint cillum consequat sunt minim sit anim voluptate.

  - type: divider
    title: Cards
    text: |
      One of may styles of cards you can write. From here you can built galleries

  - type: cards
    id: cards
    columns: 3
    cards:
      - title: Ipsum sunt
        image: images/landscape1.jpg
        text: |
          Enim ad aliquip sint exercitation culpa laborum laborum proident.

      - title: dolore laborum
        align: text-end
        image: images/landscape5.jpg
        text: |
          Magna eiusmod do ad consequat eiusmod commodo.

      - title: labore mollit
        align: text-center
        image: images/landscape2.jpg
        text: |
          Ullamco proident non commodo sint consequat Lorem pariatur qui adipisicing commodo.

      - title: excepteur id enim
        image: images/landscape4.jpg
        text: |
          Cupidatat Lorem reprehenderit ullamco irure velit irure velit.

      - title: irure amet
        image: images/landscape6.jpg
        text: |
          Deserunt nisi adipisicing ipsum labore anim non proident ullamco cupidatat anim duis.

  - type: divider
    title: Image row
    text: Some image rows with different styles

  - type: semantic
    id: section_imgrows
    element: section
    open: True

  - type: image_row
    id: imgrow1
    style: "
      padding: 6px;
      box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
      background-color: ghostwhite;
      margin: 20px 0px 20px 0px;
      "
    left: 9
    align: text-end
    title: "Aliquip eiusmod"
    image: "images/face2.jpg"
    text: |
      Cupidatat reprehenderit nulla nostrud commodo. Voluptate id tempor dolor enim occaecat proident consequat ex aute.
      Dolore Lorem deserunt incididunt minim quis minim cupidatat.

      Anim cupidatat aliquip eiusmod quis laboris pariatur. Non elit consectetur mollit nulla ex ut proident sint occaecat
      cillum. Quis voluptate ad aliquip ullamco ullamco exercitation ullamco mollit. Aliqua proident nostrud anim eiusmod et.
      Commodo magna est incididunt officia officia eu et ipsum do sunt elit.

  - type: image_row
    id: imgrow2
    style: "
      padding: 6px;
      box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
      background-color: aliceblue;
      margin: 20px 0px 20px 0px;
      "
    left: 3
    title: "Mollit dolore"
    image: "images/face5.jpg"
    text: |
      Mollit dolore **qui minim aliquip** eu. Ipsum ea sint id occaecat irure quis ullamco do veniam exercitation consectetur quis.

      ### Mollit nisi

      Mollit nisi excepteur incididunt aliquip ipsum irure ullamco magna nisi velit culpa. Duis aliquip sint excepteur duis
      Lorem reprehenderit nostrud id dolor eiusmod commodo. Excepteur dolor dolor voluptate tempor officia magna fugiat elit
      consequat aliqua laborum tempor.

  - type: image_row
    id: imgrow3
    style: "
      padding: 6px;
      box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
      margin: 20px 0px 20px 0px;
      "
    align: text-center
    left: 6
    title: "Aliqua laboris"
    image: "images/ruines1.jpg"
    text: |
      Mollit nisi excepteur incididunt aliquip ipsum irure ullamco magna nisi velit culpa. Duis aliquip sint excepteur duis
      Lorem reprehenderit nostrud id dolor eiusmod commodo. Excepteur dolor dolor voluptate tempor officia magna fugiat elit
      consequat aliqua laborum tempor.

  - type: semantic
    element: section
    id: section_imgrows
    open: False
